# Contributing

## Introduction

First off, thank you for considering contributing to `TypeManager.TS`. It's people like you that make `TypeManager.TS` such a great tool.

Following these guidelines helps to communicate that you respect the time of the developers managing and developing this open source project. In return, they should reciprocate that respect in addressing your issue, assessing changes, and helping you finalize your pull requests.

## What kinds of contributions we are looking for

`TypeManager.TS` is an open source project and we love to receive contributions from our community — you! There are many ways to contribute, from writing tutorials or blog posts, improving the documentation, submitting bug reports and feature requests or writing code which can be incorporated into `TypeManager.TS` itself.

## Ground Rules

Please read our [CODE_OF_CONDUCT.md](https://github.com/dipscope/TypeManager.TS/blob/master/CODE_OF_CONDUCT.md) file to facilitate healthy and constructive community behavior.

* Ensure that code that goes into core meets our code style.
* Create issues for any major changes and enhancements that you wish to make. Discuss things transparently and get community feedback.
* Don't add any new classes to the codebase unless absolutely needed.
* Keep feature versions as small as possible, preferably one new feature per version.
* Be welcoming to newcomers and encourage diverse new contributors from all backgrounds.

## Your First Contribution

Unsure where to begin contributing to `TypeManager.TS`? You can start by looking through the beginner and help-wanted issues. Beginner issues - issues which should only require a few lines of code, and a test or two. Help wanted issues - issues which should be a bit more involved than beginner issues.

## How to report a bug

If you find a security vulnerability, do NOT open an issue. Email dipscope@gmail.com instead. In order to determine whether you are dealing with a security issue, ask yourself these two questions:

* Can I access something that's not mine, or something I shouldn't have access to?
* Can I disable something for other people?

If the answer to either of those two questions are «yes», then you're probably dealing with a security issue. Note that even if you answer «no» to both questions, you may still be dealing with a security issue, so if you're unsure, just email us at dipscope@gmail.com.

When filing an issue, make sure to answer these five questions:

1. What version of `TypeManager.TS` are you using?
2. What browser are you using?
3. What did you do?
4. What did you expect to see?
5. What did you see instead?

## How to suggest a feature

If you find yourself wishing for a feature that doesn't exist in `TypeManager.TS`, you are probably not alone. There are bound to be others out there with similar needs. Many of the features that `TypeManager.TS` has today have been added because our users saw the need. Open an issue on our issues list on GitHub which describes the feature you would like to see, why you need it, and how it should work.

## Running the tests

If you are going to contribute make sure that all tests are passed by running `npm run test` command in the root project folder.

## Deployment

This project representing a library and can be built by running `npm run build` command. All compiled production files will be available under `dist` folder.

## Notes

We are continuously working on this file. If you have not found interesting information feel free to open an issue.
